/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_BindEditOp_h__
#define __operator_BindEditOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to interactively change wrap bindings

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT BindEditOp:
	public SurfaceBindOp,
	public Initialize<BindEditOp>
{
	public:

						BindEditOp(void):
							m_rayDepth(0),
							m_ctrled(FALSE)									{}
virtual					~BindEditOp(void)									{}

		void			initialize(void);

						//* As HandlerI
virtual	void			handle(Record& a_rSignal);

	private:

		sp<SurfaceI>	m_spInput;
		sp<SurfaceI>	m_spDriver;
		WindowEvent		m_event;
		I32				m_rayDepth;
		BWORD			m_ctrled;

		SpatialVector	m_selectPoint;
		SpatialVector	m_selectNormal;
		SpatialVector	m_bindPoint;
		SpatialVector	m_bindNormal;
};

} /* namespace */

#endif /* __operator_BindEditOp_h__ */
