/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __vegetation_OperatorTree_h__
#define __vegetation_OperatorTree_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to Sim and Draw a Tree

	@ingroup vegetation
*//***************************************************************************/
class FE_DL_EXPORT TreeOp:
	public OperatorSurfaceCommon,
	public Initialize<TreeOp>
{
	public:

					TreeOp(void);
virtual				~TreeOp(void);

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

					//* As BindI
virtual	void		bind(sp<SignalerI> spSignalerI,sp<Layout> spLayout);

	private:
		Forest						m_forestRV;
		Plant						m_plantRV;
		sp<SignalerI>				m_spSignalerI;

		std::vector< sp<HandlerI> >	m_modifierArray;
};

} /* namespace */

#endif /* __vegetation_OperatorTree_h__ */

